<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Eddie: CONTRIBUTING</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Eddie
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="PageDoc"><div class="header">
  <div class="headertitle">
<div class="title">CONTRIBUTING </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><ul>
<li><a href="#gitlab-contributions">Gitlab Contributions</a><ul>
<li><a href="#overview">Overview</a></li>
<li><a href="#commit-guidelines">Commit Guidelines</a></li>
<li><a href="#contributions-to-documentation">Contributions to Documentation</a></li>
</ul>
</li>
<li><a href="#reuse-compliance">REUSE Compliance</a><ul>
<li><a href="#spdx-information-and-reuse-standard">SPDX Information and REUSE Standard</a><ul>
<li><a href="#spdx-header-example">SPDX Header Example</a></li>
<li><a href="#substantial-contributions">Substantial Contributions</a></li>
</ul>
</li>
</ul>
</li>
<li><a href="#dco-sign-off">DCO sign-off</a><ul>
<li><a href="#overview-1">Overview</a></li>
<li><a href="#developer-certificate-of-origin">Developer Certificate of Origin</a></li>
</ul>
</li>
<li><a href="#oniro-specific-contributions-process-and-guidelines"><code>oniro</code>-specific contributions process and guidelines</a></li>
</ul>
<h1><a class="anchor" id="autotoc_md0"></a>
Gitlab Contributions</h1>
<h2><a class="anchor" id="autotoc_md1"></a>
Overview</h2>
<p>Oniro Project handles contributions as <a href="https://docs.gitlab.com/ee/user/project/merge_requests/">merge requests</a> to relevant repositories part of the Oniro Project <a href="https://gitlab.eclipse.org/eclipse/oniro-core">GitLab instance</a>. The flow for handling that is classic: fork-based merge requests. This means that once you have an account, you can fork any repository, create a branch with proposed changes and raise a merge request against the forked repository. More generic information you can find on the Gitlab's documentation as part of <a href="https://docs.gitlab.com/ee/development/contributing/merge_request_workflow.html">"Merge requests workflow"</a>.</p>
<h2><a class="anchor" id="autotoc_md2"></a>
Commit Guidelines</h2>
<div class="note"></div><div class="note"><div class="title"></div></div><div class="note"><div class="title">Note</div></div><div class="note"><div class="title"></div></div><div class="note">If you are new to <code>git</code>, start by reading the official <a href="https://git-scm.com/book/en/v2/Getting-Started-First-Time-Git-Setup">Getting Started Document</a>.</div><div class="note"></div><p>At its core, contributing to the Oniro Project project means <em>wrapping</em> your work as <code>git</code> commits. How we handle this has an impact on rebasing, cherry-picking, back-porting, and ultimately exposing consistent documentation through its logs.</p>
<p>To achieve this, we maintain the following commit guidelines:</p>
<ul>
<li>Each commit should be able to stand by itself providing a building block as part of the MR.<ul>
<li>A good balance of granularity with scoped commits helps to handle backports (e.g. cherry-picks) and also improves the ability to review smaller chunks of code taking commit by commit.</li>
</ul>
</li>
<li>Changes that were added on top of changes introduced in the MR, should be squashed into the initial commit.<ul>
<li>For example, a MR that introduced a new build system recipe and, as a separate commit, fixed a build error in the initial recipe. The latter commit should be squashed into the initial commit.</li>
<li>For example, a MR introducing a new docs chapter and also adding, as a separate commit, some typo fixes. The latter commits should be squashed into the initial commit.</li>
<li>There is a small set of exceptions to this rule. All these exceptions gravitate around the case where an MR, even if it provides multiple commits in the same scope (for example, to the same build recipe), each of the commits has a very specific purpose.<ul>
<li>For example, a line formating change followed by a chapter addition change in the same documentation file.</li>
<li>Also, it can be the case of two functional changes that are building blocks in the same scope.</li>
<li>Another example where commits are not to be squashed is when having a commit moving the code and a commit modifying the code in the new location.</li>
</ul>
</li>
</ul>
</li>
<li>Make sure you clean your code of trailing white spaces/tabs and that each file ends with a new line.</li>
<li>Avoid <em>merge</em> commits as part of your MR. Your commits should be rebased on top of the <em>HEAD</em> of the destination branch.</li>
</ul>
<p>As mentioned above, <em>git log</em> becomes informally part of the documentation of the product. Maintaining consistency in its format and content improves debugging, auditing, and general code browsing. To achieve this, we also require the following commit message guidelines:</p>
<ul>
<li>The <em>subject</em> line (the first line) needs to have the following format: <code>scope: Title limited to 80 characters</code>.<ul>
<li>Use the imperative mood in the <em>subject</em> line for the <em>title</em>.</li>
<li>The <em>scope</em> prefix (including the colon and the following whitespace) is optional but most of the time highly recommended. For example, fixing an issue for a specific build recipe, would use the recipe name as the <em>scope</em>.</li>
<li>The <em>title</em> (the part after the <em>scope</em>) starts with a capital letter.</li>
<li>The entire <em>subject</em> line shouldn't exceed 80 characters (same text wrapping rule for the commit body).</li>
</ul>
</li>
<li>The commit <em>body</em> separated by an empty line from the <em>subject</em> line.<ul>
<li>The commit <em>body</em> is optional but highly recommended. Provide a clear, descriptive text block that accounts for all the changes introduced by a specific commit.</li>
<li>The commit <em>body</em> must not contain more than 80 characters per line.</li>
</ul>
</li>
<li>The commit message will have the commit message <em>trailers</em> separated by a new line from the <em>body</em>.<ul>
<li>Each commit requires at least a <em>Signed-off-by</em> trailer line. See more as part of the <code>/contributing/dco</code> document.</li>
<li>All <em>trailer</em> lines are to be provided as part of the same text block - no empty lines in between the <em>trailers</em>.</li>
</ul>
</li>
</ul>
<p>Additional commit message notes:</p>
<ul>
<li>Avoid using special characters anywhere in the commit message.</li>
<li>Be succinct but descriptive.</li>
<li>Have at least one <em>trailer</em> as part of each commit: <em>Signed-off-by</em>.</li>
<li>You can automatically let <code>git</code> add the <em>Signed-off-by</em> by taking advantage of its <code>-s</code> argument.</li>
<li>Whenever in doubt, check the existing log on the file (<code>&lt;FILE&gt;</code>) you are about to commit changes, using something similar to: <code>git log &lt;FILE&gt;</code>.</li>
</ul>
<p>Example of a full git message:</p>
<div class="fragment"><div class="line">busybox: Add missing dependency on virtual/crypt</div>
<div class="line"> </div>
<div class="line">Since version 1.29.2, the busybox package requires virtual/crypt. Add this</div>
<div class="line">to DEPENDS to make sure the build dependency is satisfied.</div>
<div class="line"> </div>
<div class="line">Signed-off-by: Joe Developer &lt;joe.developer@example.com&gt;</div>
</div><!-- fragment --><h2><a class="anchor" id="autotoc_md3"></a>
Contributions to Documentation</h2>
<p>In Oniro Project, the documentation usually stays with the respective code repositories. This means that contributing to documentation is not in any way different than contributing to code. The processes, contribution guidelines are to remain the same. The only difference is that documentation files are to be released under <code>Creative Commons License version 4.0</code>.</p>
<p>Documentation that doesn't link directly to one specific repository, is available in the <a href="https://gitlab.eclipse.org/eclipse/oniro-core/docs">docs repository</a>.</p>
<p>In terms of file format, the project unifies its documentation as <code>ReStructuredText</code> files. A RestructuredText primer is available as part of the Sphinx <a href="https://www.sphinx-doc.org/en/master/usage/restructuredtext/basics.html">documentation</a>.</p>
<p>As a rule of thumb, anything that ends up compiled in the project documentation is to maintain the RestructuredText file format. Text files that are not meant to be compiled as part of the project's documentation can be written in <a href="https://daringfireball.net/projects/markdown/">Markdown</a>. For example, a repository <code>README</code> file can be written in Markdown as it doesn't end up compiled in the project-wide documentation.</p>
<h1><a class="anchor" id="autotoc_md4"></a>
REUSE Compliance</h1>
<h2><a class="anchor" id="autotoc_md5"></a>
SPDX Information and REUSE Standard</h2>
<p>All projects and files for an hosted project <b>MUST</b> be <a href="https://reuse.software/">REUSE</a> compliant. REUSE requires SPDX information for each file, rules for which are as follows:</p>
<ul>
<li>Any new file must have a SPDX header (copyright and license).</li>
<li>For files that don't support headers (for example binaries, patches etc.) an associated <code>.license</code> file must be included with the relevant SPDX information.</li>
<li>Do not add Copyright Year as part of the SPDX header information.</li>
<li>The general rule of thumb for the license of a patch file is to use the license of the component for which the patch applies.</li>
<li>When modifying a file through this contribution process, you may (but don't have to) claim copyright by adding a copyright line.</li>
<li>Never alter copyright statements made by others, but only add your own.</li>
</ul>
<p>Some files will make an exception to the above rules as described below:</p>
<ul>
<li>Files for which copyright is not claimed and for which this information was not trivial to fetch (for example backporting patches, importing build recipes etc. when upstream doesn't provide the SPDX information in the first place)</li>
<li>license files (for example <code>common-licenses</code> in bitbake layers)</li>
</ul>
<h3><a class="anchor" id="autotoc_md6"></a>
SPDX Header Example</h3>
<p>Make sure all of your submitted new files have a licensing statement in the headers. Please make sure that the license for your file is consistent with the licensing choice at project level and that you select the correct SPDX identifier, as in the following example for Apache 2.0 license:</p>
<div class="fragment"><div class="line">/*</div>
<div class="line"> * SPDX-FileCopyrightText: Jane Doe &lt;jane@example.com&gt;</div>
<div class="line"> *</div>
<div class="line"> * SPDX-License-Identifier: Apache-2.0</div>
<div class="line"> */</div>
</div><!-- fragment --><h3><a class="anchor" id="autotoc_md7"></a>
Substantial Contributions</h3>
<p>Therefore, if your contribution is only a patch directly applied to an existing file, then you are not required to do anything. If your contribution is an entire new project, or a substantial, copyrighted contribution, you <b>MUST</b> make sure that you do that following the <a href="https://booting.oniroproject.org/distro/governance/ip-policy">IP Policy</a> and that you comply with REUSE standard to include the licensing information where they are required.</p>
<h1><a class="anchor" id="autotoc_md8"></a>
DCO sign-off</h1>
<h2><a class="anchor" id="autotoc_md9"></a>
Overview</h2>
<p>Commits <b>MUST</b> be submitted only with a sign-off by the submitter. A commit without a sign-off will be automatically rejected. You don't need be the author or the copyright holder of the contribution, but you must make sure that you have the power to submit on behalf of those who are.</p>
<p>To sign your work, just add a line like this at the end of your commit message:</p>
<div class="fragment"><div class="line">Signed-off-by: Jane Doe &lt;jane@example.com&gt;</div>
</div><!-- fragment --><p>This could be done automatically in the <code>git</code> submission:</p>
<div class="fragment"><div class="line">git commit --signoff -m &quot;comment&quot;</div>
</div><!-- fragment --><h2><a class="anchor" id="autotoc_md10"></a>
Developer Certificate of Origin</h2>
<p>By doing this you state that you certify the following (from <a href="https://developercertificate.org/">https://developercertificate.org</a>):</p>
<div class="fragment"><div class="line">Developer Certificate of Origin</div>
<div class="line">Version 1.1</div>
<div class="line"> </div>
<div class="line">Copyright (C) 2004, 2006 The Linux Foundation and its contributors.</div>
<div class="line">1 Letterman Drive</div>
<div class="line">Suite D4700</div>
<div class="line">San Francisco, CA, 94129</div>
<div class="line"> </div>
<div class="line">Everyone is permitted to copy and distribute verbatim copies of this</div>
<div class="line">license document, but changing it is not allowed.</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">Developer&#39;s Certificate of Origin 1.1</div>
<div class="line"> </div>
<div class="line">By making a contribution to this project, I certify that:</div>
<div class="line"> </div>
<div class="line">(a) The contribution was created in whole or in part by me and I</div>
<div class="line">    have the right to submit it under the open source license</div>
<div class="line">    indicated in the file; or</div>
<div class="line"> </div>
<div class="line">(b) The contribution is based upon previous work that, to the best</div>
<div class="line">    of my knowledge, is covered under an appropriate open source</div>
<div class="line">    license and I have the right under that license to submit that</div>
<div class="line">    work with modifications, whether created in whole or in part</div>
<div class="line">    by me, under the same open source license (unless I am</div>
<div class="line">    permitted to submit under a different license), as indicated</div>
<div class="line">    in the file; or</div>
<div class="line"> </div>
<div class="line">(c) The contribution was provided directly to me by some other</div>
<div class="line">    person who certified (a), (b) or (c) and I have not modified</div>
<div class="line">    it.</div>
<div class="line"> </div>
<div class="line">(d) I understand and agree that this project and the contribution</div>
<div class="line">    are public and that a record of the contribution (including all</div>
<div class="line">    personal information I submit with it, including my sign-off) is</div>
<div class="line">    maintained indefinitely and may be redistributed consistent with</div>
<div class="line">    this project or the open source license(s) involved.</div>
</div><!-- fragment --><h1><a class="anchor" id="autotoc_md11"></a>
&lt;tt&gt;oniro&lt;/tt&gt;-specific contributions process and guidelines</h1>
<p>The project handles contributions as merge request in the project's <a href="https://git.ostc-eu.org/distro/oniro">GitLab instance</a>. See above for more details.</p>
<p>Each contributions must adhere to the <a href="http://www.openembedded.org/wiki/Commit_Patch_Message_Guidelines">OpenEmbedded Commit Patch Message Guidelines</a>. This includes (but not limited to) having a well-formatted <code>git log</code> subject. Whenever you are in doubt of the subject line format, run <code>git log ./&lt;filename&gt;</code> for examples.</p>
<p>The general format is:</p>
<div class="fragment"><div class="line">component: Subject line</div>
<div class="line"> </div>
<div class="line">Optional description.</div>
<div class="line"> </div>
<div class="line">Signed-off-by: Joe Developer &lt;joe.developer@example.com&gt;</div>
</div><!-- fragment --><p>Please note that by signing off the commit, you make a <b>legally binding statement</b> that you certify as in the <a href="#dco-sign-off">DCO sign-off</a> section. </p>
</div></div><!-- contents -->
</div><!-- PageDoc -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1
</small></address>
</body>
</html>
